(****************************************************************************)
(*                          NEDIDEL GLI PARDUOTUV                       *)
(*                          IOI'99, Antalija, Turkija                       *)
(*                      Programos autorius: Antanas Kompanas                *)
(****************************************************************************)

program flower;

const
  maxF = 100; { Ribojimai, gali kisti intervale [0..255] }
  maxV = 100;

type
  TEstVertes = array[1..maxF, 1..maxV] of ShortInt; { Est. reikmi masyvas  }
  TDinLent   = array[1..maxF, 1..maxV] of record    { Din. duomen lentel }
                   { Maksimali estetin reikm } maxEv: Integer;
              { Gl, po kurios pamerkta } po: Byte;
                                          end;

(* Maksimamaliai reikmei saugoti naudojamas Integer tipas, nes didiausia *)
(* estetin reikm gali bti intervale [-5000; 5000] (50 * F = 5000)   *)

var
  geliu, vazu: Byte; { Pradiniai duomenys - F, V }
  ev: TEstVertes;      { ir estetins reikms }
  max: Integer;      { Kintamieji, naudojami rasti maksimumui }
  maxG: Byte;          { ir laikyti atsakymui }
  d: TDinLent;       { Dinamini duomen lentel }


procedure ivesti; { veda pradinius duomenis }
var
  f: Text;
  i, j: Byte;
begin
  assign(f, 'flower.inp');
  reset(f);
    readln(f, geliu, vazu);
    for i := 1 to geliu do { F eilui }
      begin
        for j := 1 to vazu do { V stulpeli }
          read(f, ev[i, j]);
        readln(f);
      end;
  close(f);
end;

procedure spresti; { Sprendia udavin }
var
  i, j, k: ShortInt;
begin
  { Pirm eilut upildome pradini duomen reikmmis }
  for i := 1 to 1 - geliu + vazu do
    with d[1, i] do
      begin
        po := 0;
        maxEv := ev[1, i];
      end;
  { Pildome likusias F-1 eilutes }
  for i := 2 to geliu do
    for j := i to i - geliu + vazu do { Tik reikiami stulpeliai }
      begin
        max := -maxint;
        { Iekome didiausios reikms i-1 eilutje }
        for k := i - 1 to j - 1 do
          with d[i - 1, k] do
            if maxEv > max then
              begin
                max := maxEv;
                maxG := k;
              end;
        { Upildome langel(j, i) }
        with d[i, j] do
          begin
            maxEv := ev[i, j] + max;
            po := maxG;
          end;
      end;
  { Iekome didiausios reikms paskutinje eilutje }
  max := -maxint;
  for i := geliu to vazu do
    with d[geliu, i] do
      if maxEv > max then
        begin
          max := maxEv;
          maxG := i;
        end;
  { Atsakymas: maxEv, paskutin gl pamerkta  maxG vaz }
end;

procedure isvesti; { Spaudinimas }
var
  f: Text;

  procedure atbulai(const gele, vaza: Byte); { Spausdina vaz sek nuo galo }
  begin                                      {  / plg. paieka  gyl /  }
    if gele > 1 then atbulai(gele - 1, d[gele, vaza].po);
    if gele = geliu
      then write(f, vaza)
      else write(f, vaza, ' ');
  end;

begin
  assign(f, 'flower.out');
  rewrite(f);
  writeln(f, max);
  atbulai(geliu, maxG);
  close(f);
end;

begin
  ivesti;
  spresti;
  isvesti;
end.
